<?php

class Sablog2ToTypecho_Action extends Typecho_Widget implements Widget_Interface_Do
{
	private static $_db;
	
	private static $_options;
	
    public function doImport()
    {
        self::$_options = $this->widget('Widget_Options');
        $dbConfig = self::$_options->plugin('Sablog2ToTypecho');

        /** 初始化一个db */
        if (Typecho_Db_Adapter_Mysql::isAvailable()) {
            self::$_db = new Typecho_Db('Mysql', $dbConfig->prefix);
        } else {
            self::$_db = new Typecho_Db('Pdo_Mysql', $dbConfig->prefix);
        }
        /** 只读即可 */
        self::$_db->addServer(array (
          'host' => $dbConfig->host,
          'user' => $dbConfig->user,
          'password' => $dbConfig->password,
          'charset' => 'utf8',
          'port' => $dbConfig->port,
          'database' => $dbConfig->database
        ), Typecho_Db::READ);
        
        /** 删除当前内容 */
        $masterDb = Typecho_Db::get();
        $this->widget('Widget_Abstract_Contents')->to($contents)->delete($masterDb->sql()->where('1 = 1'));
        $this->widget('Widget_Abstract_Comments')->to($comments)->delete($masterDb->sql()->where('1 = 1'));
        $this->widget('Widget_Abstract_Metas')->to($metas)->delete($masterDb->sql()->where('1 = 1'));
        $this->widget('Widget_Contents_Post_Edit')->to($edit);
        $masterDb->query($masterDb->delete('table.relationships')->where('1 = 1'));
        $userId = $this->widget('Widget_User')->uid;
        /** 转换文章 */
        $i = 1;
        
        while (true) {
            $result = self::$_db->query(self::$_db->select()->from('table.articles')
            ->order('articleid', Typecho_Db::SORT_ASC)->page($i, 100));
            $j = 0;
            
            while ($row = self::$_db->fetchRow($result)) {
				$row['content'] = preg_replace_callback("/\[attach=(\d+)\]/",  array(&$this, 'getAttachCallBack'), $row['content']);
                $contents->insert(array(
                    'cid'           =>  $row['articleid'],
                    'title'         =>  $row['title'],
                    'slug'          =>  Typecho_Common::slugName(urldecode($row['alias']), $row['articleid'], 128),
                    'created'       =>  $row['dateline'],
                    'modified'      =>  $row['dateline'],
                    'text'          =>  $row['content'],
                    'order'         =>  '0',
                    'authorId'      =>  $row['uid'],
                    'template'      =>  NULL,
                    'type'          =>  'post',
                    'status'        =>  'publish',
                    'password'      =>  $row['readpassword'],
                    'commentsNum'   =>  $row['comments'],
                    'allowComment'  =>  '1',
                    'allowFeed'     =>  '1',
                    'allowPing'     =>  '1',
                ));
                
                $j ++;
                unset($row);
            }
            
            if ($j < 100) {
                break;
            }
            
            $i ++;
            unset($result);
        }
		
		/** 附件写入数据库 */
		$i = 1;
		
		$result = self::$_db->query(self::$_db->select()->from('table.settings'));
		while($settingDb = self::$_db->fetchRow($result))
		{
			$saSetting[$settingDb['title']] = $settingDb['value'];
		}
		unset($result);
		
		while(true)
		{
			$result = self::$_db->query(self::$_db->select()->from('table.attachments')
			->order('attachmentid', Typecho_Db::SORT_ASC)->page($i, 100));
			$j = 0;
			while($attach = self::$_db->fetchRow($result))
			{
				if(!file_exists( __TYPECHO_ROOT_DIR__ . "/" . $saSetting['attachments_dir'] . $attach['filepath'])) {
					break;
				}
				$attach['newfilepath'] = "/" . $saSetting['attachments_dir'] . substr($attach['filepath'], 0, strrpos($attach['filepath'], '.')) . substr($attach['filename'], strrpos($attach['filename'], '.'));
				rename(__TYPECHO_ROOT_DIR__ . "/" . $saSetting['attachments_dir'] . $attach['filepath'], __TYPECHO_ROOT_DIR__ . $attach['newfilepath']);
				$attach['slug'] = Typecho_Common::slugName(urldecode($attach['filename']));

				$extend =explode("." , $attach['filename']);
				$va=count($extend)-1;
				$attach['ext'] = $extend[$va];
				
				$attach['text'] = 'a:10:{s:4:"name";s:' . strlen($attach['filename']) . ':"' . $attach['filename'] . 				'";s:4:"path";s:' . strlen($attach['newfilepath']) . ':"' . $attach['newfilepath'] . '";s:4:"size";i:' . $attach['filesize'] . ';s:4:"type";s:' . strlen($attach['ext']) . ':"' . $attach['ext'] . '";s:4:"mime";s:' . strlen($attach['filetype']) . ':"' . $attach['filetype'] .'";s:12:"uploadHandle";' . 'a:2:{i:0;s:13:"Widget_Upload";i:1;s:12:"uploadHandle";}s:12:"deleteHandle";' . 'a:2:{i:0;s:13:"Widget_Upload";i:1;s:12:"deleteHandle";}s:12:"modifyHandle";' . 'a:2:{i:0;s:13:"Widget_Upload";i:1;s:12:"modifyHandle";}s:16:"attachmentHandle";' . 'a:2:{i:0;s:13:"Widget_Upload";i:1;s:16:"attachmentHandle";}s:20:"attachmentDataHandle";' . 'a:2:{i:0;s:13:"Widget_Upload";i:1;s:20:"attachmentDataHandle";}' . '}';
                $contents->insert(array(
                    'title'         =>  $attach['filename'],
                    'slug'          =>  $attach['slug'],
                    'created'       =>  $attach['dateline'],
                    'modified'      =>  $attach['dateline'],
                    'text'          =>  $attach['text'],
                    'order'         =>  $attach['articleid'],
                    'authorId'      =>  1,
                    'template'      =>  NULL,
                    'type'          =>  'attachment',
                    'status'        =>  'publish',
                    'password'      =>  NULL,
                    'commentsNum'   =>  '0',
                    'allowComment'  =>  '1',
                    'allowFeed'     =>  '1',
                    'allowPing'     =>  '0',
                ));
				$j++;
				unset($attach);
			}
			if($j < 100)
			{
				break;
			}
			$i++;
			unset($result);
		}
		
		/** 转换 Sablog-x 2.0 的Tags */
		$tags = self::$_db->fetchAll(self::$_db->select()->from('table.tags')
   	    ->order('tagid', Typecho_Db::SORT_ASC));
       	foreach ($tags as $tag)
		{
           	$metas->insert(array(
               	'mid'           =>  $tag['tagid'],
                'name'          =>  $tag['tag'],
                'slug'          =>  Typecho_Common::slugName(urldecode($tag['tag'])),
                'type'      	=>  'tag',
                'description'   =>  NULL,
                'count'      	=>  $tag['usenum'],
				'order'         =>  '0',
            ));
            /** 转换关系表 */
			$tagrelations = explode(",",$tag['aids']);
            foreach ($tagrelations as $cid) {
                $masterDb->query($masterDb->insert('table.relationships')->rows(array(
   	                'cid'      	=>  $cid,
       	            'mid'   	=>  $tag['tagid'],
           	    )));
            }
        }
		
		/** 转换分类 */
		$categories = self::$_db->fetchAll(self::$_db->select()->from('table.categories')->order('displayorder', Typecho_Db::SORT_ASC));
		foreach ($categories as $category) {
            $lastid = $metas->insert(array(
                'name'          =>  $category['name'],
                'slug'          =>  $category['url'],
                'type'      	=>  'category',
                'description'   =>  NULL,
                'count'      	=>  $category['articles'],
				'order'         =>  $category['displayorder'],
            ));

			$art = self::$_db->fetchAll(self::$_db->select('articleid')->from('table.articles')
			->where('cid = ?', $category['cid'])
			->order('articleid', Typecho_Db::SORT_ASC));
			foreach ($art as $value) {
           	    $masterDb->query($masterDb->insert('table.relationships')->rows(array(
               	    'cid'      	=>  $value['articleid'],
                   	'mid'   	=>  $lastid,
                )));
			}
		}

        /** 转换评论 */
        $i = 1;
        
        while (true) {
            $result = self::$_db->query(self::$_db->select()->from('table.comments')
            ->order('commentid', Typecho_Db::SORT_ASC)->page($i, 100));
            $j = 0;
            
            while ($row = self::$_db->fetchRow($result)) {
                $status = $row['visible'];
                if ('0' == $row['visible']) {
                    $status = 'spam';
                } else {
                    $status = 'approved';
                }
                
                $row['content'] = preg_replace(
                array("/\s*<p>/is", "/\s*<\/p>\s*/is", "/\s*<br\s*\/>\s*/is",
                "/\s*<(div|blockquote|pre|table|ol|ul)>/is", "/<\/(div|blockquote|pre|table|ol|ul)>\s*/is"),
                array('', "\n\n", "\n", "\n\n<\\1>", "</\\1>\n\n"), 
                $row['content']);
            
                $comments->insert(array(
                    'coid'      =>  $row['commentid'],
                    'cid'       =>  $row['articleid'],
                    'created'   =>  $row['dateline'],
                    'author'    =>  $row['author'],
                    'authorId'  =>  $row['authorid'],
                    'ownerId'   =>  1,
                    'mail'      =>  $row['email'],
                    'url'       =>  $row['url'],
                    'ip'        =>  $row['ipaddress'],
                    'agent'     =>  'Powered by http://HJin.me',
                    'text'      =>  $row['content'],
                    'type'      =>  'comment',
                    'status'    =>  $status,
                    'parent'    =>  '0'
                ));
                $j ++;
                unset($row);
            }
            
            if ($j < 100) {
                break;
            }
            
            $i ++;
            unset($result);
        }
        
        $this->widget('Widget_Notice')->set(_t("数据已经转换完成"), NULL, 'success');
        $this->response->goBack();
    }

    public function action()
    {
        $this->widget('Widget_User')->pass('administrator');
        $this->on($this->request->isPost())->doImport();
    }

	public function getAttachCallBack($matches)
	{

		$result = self::$_db->query(self::$_db->select()->from('table.settings'));
		while($settingDb = self::$_db->fetchRow($result))
		{
			$saSetting[$settingDb['title']] = $settingDb['value'];
		}
		
		$result = self::$_db->query(self::$_db->select()->from('table.attachments')
		->where('attachmentid = ?', $matches[1]));
		
		while($Attachment = self::$_db->fetchRow($result))
		{
		if($Attachment['filetype'] == 'image/jpeg' || $Attachment['filetype'] == 'image/pjpeg'){
			return '<img src="' . self::$_options->siteUrl . $saSetting['attachments_dir'] . $Attachment['filepath'] . '" alt="' . $Attachment['filename'] . '" border="0">';
		}
		else if($Attachment['filetype'] == 'image/png'){
			return '<img src="' . self::$_options->siteUrl . $saSetting['attachments_dir'] . $Attachment['filepath'] . '" alt="' . $Attachment['filename'] . '" border="0">';
		}
		else if($Attachment['filetype'] == 'image/gif'){
			return '<img src="' . self::$_options->siteUrl . $saSetting['attachments_dir'] . $Attachment['filepath'] . '" alt="' . $Attachment['filename'] . '" border="0">';
		}
		else{
			$urlpath = self::$_options->siteUrl . $saSetting['attachments_dir'] . substr($Attachment['filepath'], 0, strrpos($Attachment['filepath'], '.')) . substr($Attachment['filename'], strrpos($Attachment['filename'], '.'));
			return '<a href="' . $urlpath . '">' . $Attachment['filename'] . '</a>';
		}
		}
	}
}
